// Prikaz Podataka iz Halo Chipcard na LCD 16x2 4-bit v1.0 [keil c]
// HARDWER: 
//     # uCU AT89C2051
//     # Xtal 24Mhz
//     # INPUT: Haloo_ChipCard
//
// datum_start: 25.septembar 2002.

#include <reg51.h>

// temporary for mon_51
unsigned char eep_sfra_temp[4]={0x33,0x44,0x21,0x55}; 

int clock=0;    // brojaci u tajmeru
int clock1=0;   //

unsigned char i,j=0;  // univerzalne za petlje

bit fleg_senzori=0;    // okidaci u tajmeru
bit samo_jednom=0; // ukoliko se taster pritisne ceka se njegovo
                   // otpustanje za nastavak kolekcioniranja sledecih
bit samo_jednom_detektuj=1; // za detekciju ubacivanja chip_kartice

//-----------------------------------------------------------
//             Procedure za kontrolu LCD-a  HD44780 16x2 
//-----------------------------------------------------------
sbit RS    = P3^5; //   
sbit E     = P3^4; //   
sbit data7 = P3^3; //   LCD
sbit data6 = P3^2; //   
sbit data5 = P3^1; //   
sbit data4 = P3^0; //   

void delay_ms(unsigned char koliko)
{
  unsigned int i;
  for(i=0;i<=(koliko*50);i++);
}

void clock_E()
{
  delay_ms(2);
  E = 1;
  delay_ms(2);
  E = 0;
  //delay_ms(1);
}

void Put_LCD4(unsigned char ins, unsigned char command)
{                                            
  unsigned char h_nible,l_nible;
  // USAGE: Put_LCD4(podatak, komanda)
  //{komanda: RS=0 Instruction; RS=1 data}
  // if(command==1) RS=1; else RS=0;
  RS=command;
  h_nible=(ins&0xf0)>>4; // gornji nibl
  P3&=0xf0;           // postavi na port 3_2_1_0
  P3|=h_nible;              // 
  clock_E();
  l_nible=ins&0x0f;      // donji nibl
  P3&=0xf0;           // postavi na port 3_2_1_0 
  P3|=l_nible;
  clock_E();
}     


void Put_Char(char character, unsigned char _gotox,unsigned char _gotoy)
{ // napomena radi se sa 16x2 karaktera LCD-om                                  
  // USAGE: Put_Char(koji znak, x koordinata, y koordinata)
  // x = 0..15 ;  y = 0 ili 1;
  Put_LCD4(0x80+_gotox+(0x40*_gotoy),0);
  Put_LCD4(character,1);
}     

void PutLCDnum(unsigned int innt, unsigned char _x, unsigned _y)
{ // Slanje numerika na LCD displej)   za 16x2 displej
  // USAGE: PutLCDnum(broj, x, y)
  //        x - colona 0..15
  //        y - red 0 ili 1
  int j;
  Put_LCD4(0x80+_x+(0x40*_y),0); //pozicioniraj se
  j=innt/100;  
  innt=innt-(j*100);
  Put_LCD4(j+48,1);
  j=innt/10;  
  innt=innt-(j*10);
  Put_LCD4(j+48,1);
  Put_LCD4(innt+48,1);
}

void PutLCDnum_int(unsigned int innt, unsigned char _x, unsigned _y)
{ // Slanje integer numerika na LCD displej)   za 16x2 displej
  // USAGE: PutLCDnum(broj, x, y)
  //        x - colona 0..15
  //        y - red 0 ili 1
  int j, temp_deljenje;
  Put_LCD4(0x80+_x+(0x40*_y),0); //pozicioniraj se
  if(innt>10000)
  {
    temp_deljenje=(innt/10000);
    Put_LCD4(temp_deljenje+48,1);
    innt-=temp_deljenje*10000;
  }
  else
  {
    Put_LCD4(0+48,1);
  }

  if(innt>1000)
  {
    temp_deljenje=(innt/1000);
    Put_LCD4(temp_deljenje+48,1);
    innt-=temp_deljenje*1000;
  }
  else
  {
    Put_LCD4(0+48,1);
  }

  if(innt>100)
  {
    temp_deljenje=(innt/100);
    Put_LCD4(temp_deljenje+48,1);
    innt-=temp_deljenje*100;
  }
  else
  {
    Put_LCD4(0+48,1);
  }

  Put_LCD4('.',1);

  if(innt>10)
  {
    temp_deljenje=(innt/10);
    Put_LCD4(temp_deljenje+48,1);
    innt-=temp_deljenje*10;
  }
  else
  {
    Put_LCD4(0+48,1);
  }

  Put_LCD4(innt+48,1);
}


//-----------------------------------------------------------
//          Procedura za citanje Halo_chip karitce
//-----------------------------------------------------------

sbit Halo_Vcc    = P1^6; // Napajanje Halo_chip kartice
sbit Halo_Detect = P1^4; // Prekidac za detekciju Halo_chip kartice
sbit Halo_Out    = P1^2; // Pin OUT   Halo_chip kartice
sbit Halo_Rst    = P1^1; // Pin RESET Halo_chip kartice
sbit Halo_Clk    = P1^0; // Pin CLK   Halo_chip kartice

unsigned char shift_in()
{
  unsigned char n;
  unsigned char k;
  unsigned char dat;
  k=128;              // STR=0
  dat=0;
  for(n=1;n<=8;n++)
  {
    delay_ms(1);
    if(!Halo_Out)      //  pazi invertovano !!!!!!
    {
      dat+=k;         // data=1
	}
    Halo_Clk=1;
    Halo_Clk=0;       // clock=0
    k=k>>1;           // k=k/2
  }
  return(dat);
}

unsigned char shift_in_kredit()
{
  unsigned char n;
  unsigned char g;
  g=8;
  for(n=1;n<=8;n++)
  {
    delay_ms(1);
    if(!Halo_Out)      //  pazi invertovano !!!!!!
    {
      g--;         // data=1
	}
    Halo_Clk=1;
    Halo_Clk=0;       // clock=0
  }
  return(g);
}

void chipcard_read(unsigned char koja_memorijska_lokacija, unsigned char rw)
{
  unsigned int kred, temp_kredit ,m;
  if(Halo_Detect) // ako ubacimo karticu u slot
  {
    if(samo_jednom_detektuj)
    {
	    samo_jednom_detektuj=0;
      Halo_Vcc=0; // ukljucujemo napjanje Halo kartice

      Put_LCD4(0x01,0); // clear display
      Put_LCD4(0x02,0); // display & cursor home

      // HALO INIT
      Halo_Clk=0;
      Halo_Rst=0;
      delay_ms(100);           // sacekaj
      Halo_Clk=1;
      Halo_Rst=1;
      delay_ms(2);           // sacekaj
      Halo_Rst=0;
      delay_ms(2);           // sacekaj
      // CITANJE KARTICE
      // 'preskacemo prva cetiri bajta (bajt 0-3) 1..32 (znaci 4*8bita)
      for(i=1;i<=32;i++)
      {
        Halo_Clk=1;  // klokujemo je samo
        Halo_Clk=0;
        delay_ms(1);
      }
      // 'citamo ser. broj kartice bajtovi od 4 do 7
      for(i=0;i<=3;i++)
      {
        eep_sfra_temp[i]=shift_in();
      }
      // prikazi na displej
	    for(i=0;i<=3;i++)
      {
        PutLCDnum(eep_sfra_temp[i], i*4, 0);
      }
      // sracunaj i prikazi kredit bajtovi od 8 do 12
      kred=0;
  	  m=4096;
	    for(i=0;i<=4;i++)  // 5 bajta   
      {
        kred=kred+m*shift_in_kredit();
        m=m/8;
      }
      temp_kredit=(kred*2); // /100;
 	    PutLCDnum_int(temp_kredit , 1, 1);

      Put_Char('D',7,1);     
      Put_Char('i',8,1);     
      Put_Char('n',9,1);     
      Put_Char('a',10,1);     
      Put_Char('r',11,1);     
      Put_Char('a',12,1);     
    }
  }
  else
  {
    if(!samo_jednom_detektuj)
	  {
      Put_LCD4(0x01,0); // clear display
      Put_LCD4(0x02,0); // display & cursor home

      Put_Char('C',2,0);     
      Put_Char('e',3,0);     
      Put_Char('k',4,0);     
      Put_Char('a',5,0);     
      Put_Char('m',6,0);     
      Put_Char(' ',7,0);     
      Put_Char('k',8,0);     
      Put_Char('a',9,0);     
      Put_Char('r',10,0);     
      Put_Char('t',11,0);     
      Put_Char('i',12,0);     
      Put_Char('c',13,0);     
      Put_Char('u',14,0);     
	  }
    samo_jednom_detektuj=1;
    Halo_Vcc=1; // Gasimo napajanje Halo kartice
  }
}

//-----------------------------------------------------------
//                   Tajmer0 interapt
//-----------------------------------------------------------
timer0int() interrupt 1
{   // ide na 125uS
  clock++;
  if(clock>39)      // 39 = 5ms
  {
    clock = 0;      // ide na 5ms
    clock1++;
    fleg_senzori=1;
    if(clock1>99)  // za 1sek = 199
    { // ide na 0.5 sek
      clock1 = 0;                   //
    }
  }
}

//-----------------------------------------------------------
//                   Tajmer 1 interapt
//-----------------------------------------------------------
timer1int() interrupt 3
{   // ide na 250uS
  TL1  = 0x0c;    // Tajmer1 izaziva interapt na 250us (65536-65036=500) */
  TH1  = 0xfe;    // Tajmer1 izaziva interapt na 250us () */
}

//-----------------------------------------------------------
//           ########### Main routine ############
//-----------------------------------------------------------
main()
{
  //  main_init ----------------------------------------------
  EA=0;              // GIE = 0
  TMOD = 0x12;       // 0001 0010 <= TMR0= mod 2 auto reload 8 bitni*/
                     //  ^= TMR1=mod 1 16-bit tajmer
  TCON = 0x50;       // TCON = 01010000 => pokreni Tajmer0 i 1*/
  TH0  = 0x06;       // Tajmer0 izaziva interapt na 125us (256-250) */
  TL1  = 0x0c;       // Tajmer1 izaziva interapt na 250us (65536-65036=500) */
  TH1  = 0xfe;       // Tajmer1 izaziva interapt na 250us () */
  IE   = 0x02+0x08;  // 00001010 Dozvoljen interapt TMR0 i TMR1*/

  EA = 1;            // dozvoli interapte

  //  main_init End ------------------------------------------


  Halo_Vcc = 1; // GASI !!!!!!! Napajanje Halo_chip kartice


 // MAIN RUTINA ************************************************

  // LCD inicijalizacija
  Put_LCD4(0x03,0);  // {8 bit interface/and wait 5ms}
  Put_LCD4(0x03,0);  // {8 bit interface/and wait 160uS}
  Put_LCD4(0x03,0);  // {8 bit interface/and wait 160uS}
  Put_LCD4(0x02,0);  // {4 bit interface}
  delay_ms(100);     // sacekaj malo
  Put_LCD4(32+8,0);  // {4bit, 2 reda, 5x7 <= 00101000}
  Put_LCD4(0x06,0);  // {increment position, display shift off  <= 0000 0110}
  Put_LCD4(0x0C,0);  // { Display = On, Cursor = Off, Blink = Off <= 1100}
		
  Put_LCD4(0x01,0); // clear display
  Put_LCD4(0x02,0); // display & cursor home
  Put_LCD4(0x0f,0); // display on & cursor on & blink


  Put_LCD4(0x01,0); // clear display
  Put_LCD4(0x02,0); // display & cursor home

  Put_Char('U',2,0);     
  Put_Char('b',3,0);     
  Put_Char('a',4,0);     
  Put_Char('c',5,0);     
  Put_Char('i',6,0);     
  Put_Char(' ',7,0);     
  Put_Char('k',8,0);     
  Put_Char('a',9,0);     
  Put_Char('r',10,0);     
  Put_Char('t',11,0);     
  Put_Char('i',12,0);     
  Put_Char('c',13,0);     
  Put_Char('u',14,0);     

  while(1)
  {
     // beskonacna petlja tj. TELO programa
    if(fleg_senzori)       // ide na 5ms
    {
      chipcard_read(1,1);
    }
  }
}
